import { BaseNative, GestureHandlerStateEvent, GestureHandlerTouchEvent, GestureState, GestureStateEventData, GestureTouchEventData, HandlerType, install, Manager as ManagerBase, OptionsTypeMap, TypeMap, ViewDisposeEvent, ViewInitEvent } from './gesturehandler.common';
import { View } from '@nativescript/core/ui/core/view';
import { HandlerOptions } from './gesturehandler';
export { GestureState, GestureHandlerStateEvent, GestureHandlerTouchEvent, GestureStateEventData, GestureTouchEventData, HandlerType, install, ViewInitEvent, ViewDisposeEvent };
export declare class HandlerDelegate extends NSObject implements GestureHandlerDelegate {
    static ObjCProtocols: {
        prototype: GestureHandlerDelegate;
    }[];
    private _owner;
    static new(): HandlerDelegate;
    initWithOwner(owner: WeakRef<Handler<any, any>>): HandlerDelegate;
    gestureHandlerDidChangeStatePrevStateExtraDataView(handler: GestureHandler, state: GestureHandlerState, prevState: GestureHandlerState, extraData: GestureHandlerEventExtraData, view: UIView & {
        nsView?: WeakRef<View>;
    }): void;
    gestureHandlerTouchEventOnViewStateExtraData(handler: GestureHandler, view: UIView & {
        nsView?: WeakRef<View>;
    }, state: GestureHandlerState, extraData: GestureHandlerEventExtraData): void;
}
export declare class Handler<T extends GestureHandler, U extends HandlerOptions> extends BaseNative<T, U> {
    manager: WeakRef<Manager>;
    delegate: HandlerDelegate;
    enabled: boolean;
    shouldCancelWhenOutside: boolean;
    createNative(): any;
    attachToView(view: View): void;
    detachFromView(view: View): void;
    getTag(): number;
    setTag(value: any): void;
    getView(): any;
    cancel(): void;
}
export declare class Manager extends ManagerBase {
    _manager: GestureHandlerManager;
    readonly manager: GestureHandlerManager;
    static sManager: Manager;
    static getInstance(): Manager;
    createGestureHandler<T extends HandlerType>(handlerName: T, handlerTag: number, config?: OptionsTypeMap[T]): TypeMap[T];
    viewListeners: Map<View, Map<number, {
        init: () => void;
        dispose: () => void;
    }>>;
    attachGestureHandler(handlerTag: number, view: View): void;
    detachGestureHandler(handlerTag: number, view: View): void;
}
